# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2022. Licensed under the AGPL and commercial licences.

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import os
import sys
import unittest

import obp_python
from obp_python.rest import ApiException
from obp_python.apis.account_api import AccountApi


class TestAccountApi(unittest.TestCase):
    """ AccountApi unit test stubs """

    def setUp(self):
        self.api = obp_python.apis.account_api.AccountApi()

    def tearDown(self):
        pass

    def test_o_b_pv1_2_1_delete_view_for_bank_account(self):
        """
        Test case for o_b_pv1_2_1_delete_view_for_bank_account

        Delete View
        """
        pass

    def test_o_b_pv2_0_0_get_permissions_for_bank_account(self):
        """
        Test case for o_b_pv2_0_0_get_permissions_for_bank_account

        Get access
        """
        pass

    def test_o_b_pv2_0_0_public_accounts_all_banks(self):
        """
        Test case for o_b_pv2_0_0_public_accounts_all_banks

        Get Public Accounts at all Banks
        """
        pass

    def test_o_b_pv2_0_0_public_accounts_at_one_bank(self):
        """
        Test case for o_b_pv2_0_0_public_accounts_at_one_bank

        Get Public Accounts at Bank
        """
        pass

    def test_o_b_pv3_0_0_core_private_accounts_all_banks(self):
        """
        Test case for o_b_pv3_0_0_core_private_accounts_all_banks

        Get Accounts at all Banks (private)
        """
        pass

    def test_o_b_pv3_0_0_create_view_for_bank_account(self):
        """
        Test case for o_b_pv3_0_0_create_view_for_bank_account

        Create View
        """
        pass

    def test_o_b_pv3_0_0_get_accounts_held(self):
        """
        Test case for o_b_pv3_0_0_get_accounts_held

        Get Accounts Held
        """
        pass

    def test_o_b_pv3_0_0_get_core_transactions_for_bank_account(self):
        """
        Test case for o_b_pv3_0_0_get_core_transactions_for_bank_account

        Get Transactions for Account (Core)
        """
        pass

    def test_o_b_pv3_0_0_get_other_account_by_id_for_bank_account(self):
        """
        Test case for o_b_pv3_0_0_get_other_account_by_id_for_bank_account

        Get Other Account by Id
        """
        pass

    def test_o_b_pv3_0_0_get_other_accounts_for_bank_account(self):
        """
        Test case for o_b_pv3_0_0_get_other_accounts_for_bank_account

        Get Other Accounts of one Account
        """
        pass

    def test_o_b_pv3_0_0_get_permission_for_user_for_bank_account(self):
        """
        Test case for o_b_pv3_0_0_get_permission_for_user_for_bank_account

        Get Account access for User
        """
        pass

    def test_o_b_pv3_0_0_get_private_account_idsby_bank_id(self):
        """
        Test case for o_b_pv3_0_0_get_private_account_idsby_bank_id

        Get Accounts at Bank (IDs only)
        """
        pass

    def test_o_b_pv3_0_0_get_public_account_by_id(self):
        """
        Test case for o_b_pv3_0_0_get_public_account_by_id

        Get Public Account by Id
        """
        pass

    def test_o_b_pv3_0_0_get_transactions_for_bank_account(self):
        """
        Test case for o_b_pv3_0_0_get_transactions_for_bank_account

        Get Transactions for Account (Full)
        """
        pass

    def test_o_b_pv3_0_0_private_accounts_at_one_bank(self):
        """
        Test case for o_b_pv3_0_0_private_accounts_at_one_bank

        Get Accounts at Bank (Minimal)
        """
        pass

    def test_o_b_pv3_0_0_update_view_for_bank_account(self):
        """
        Test case for o_b_pv3_0_0_update_view_for_bank_account

        Update View
        """
        pass

    def test_o_b_pv3_1_0_check_funds_available(self):
        """
        Test case for o_b_pv3_1_0_check_funds_available

        Check Available Funds
        """
        pass

    def test_o_b_pv3_1_0_create_account_application(self):
        """
        Test case for o_b_pv3_1_0_create_account_application

        Create Account Application
        """
        pass

    def test_o_b_pv3_1_0_create_account_attribute(self):
        """
        Test case for o_b_pv3_1_0_create_account_attribute

        Create Account Attribute
        """
        pass

    def test_o_b_pv3_1_0_get_account_application(self):
        """
        Test case for o_b_pv3_1_0_get_account_application

        Get Account Application by Id
        """
        pass

    def test_o_b_pv3_1_0_get_account_applications(self):
        """
        Test case for o_b_pv3_1_0_get_account_applications

        Get Account Applications
        """
        pass

    def test_o_b_pv3_1_0_get_checkbook_orders(self):
        """
        Test case for o_b_pv3_1_0_get_checkbook_orders

        Get Checkbook orders
        """
        pass

    def test_o_b_pv3_1_0_update_account(self):
        """
        Test case for o_b_pv3_1_0_update_account

        Update Account
        """
        pass

    def test_o_b_pv3_1_0_update_account_application_status(self):
        """
        Test case for o_b_pv3_1_0_update_account_application_status

        Update Account Application Status
        """
        pass

    def test_o_b_pv3_1_0_update_account_attribute(self):
        """
        Test case for o_b_pv3_1_0_update_account_attribute

        Update Account Attribute
        """
        pass

    def test_o_b_pv4_0_0_add_account(self):
        """
        Test case for o_b_pv4_0_0_add_account

        Create Account (POST)
        """
        pass

    def test_o_b_pv4_0_0_add_tag_for_view_on_account(self):
        """
        Test case for o_b_pv4_0_0_add_tag_for_view_on_account

        Create a tag on account
        """
        pass

    def test_o_b_pv4_0_0_create_counterparty(self):
        """
        Test case for o_b_pv4_0_0_create_counterparty

        Create Counterparty (Explicit)
        """
        pass

    def test_o_b_pv4_0_0_create_counterparty_for_any_account(self):
        """
        Test case for o_b_pv4_0_0_create_counterparty_for_any_account

        Create Counterparty for any account (Explicit)
        """
        pass

    def test_o_b_pv4_0_0_create_direct_debit(self):
        """
        Test case for o_b_pv4_0_0_create_direct_debit

        Create Direct Debit
        """
        pass

    def test_o_b_pv4_0_0_create_direct_debit_management(self):
        """
        Test case for o_b_pv4_0_0_create_direct_debit_management

        Create Direct Debit (management)
        """
        pass

    def test_o_b_pv4_0_0_create_or_update_account_attribute_definition(self):
        """
        Test case for o_b_pv4_0_0_create_or_update_account_attribute_definition

        Create or Update Account Attribute Definition
        """
        pass

    def test_o_b_pv4_0_0_create_standing_order(self):
        """
        Test case for o_b_pv4_0_0_create_standing_order

        Create Standing Order
        """
        pass

    def test_o_b_pv4_0_0_create_standing_order_management(self):
        """
        Test case for o_b_pv4_0_0_create_standing_order_management

        Create Standing Order (management)
        """
        pass

    def test_o_b_pv4_0_0_create_user_with_account_access(self):
        """
        Test case for o_b_pv4_0_0_create_user_with_account_access

        Create (DAuth) User with Account Access
        """
        pass

    def test_o_b_pv4_0_0_delete_account_attribute_definition(self):
        """
        Test case for o_b_pv4_0_0_delete_account_attribute_definition

        Delete Account Attribute Definition
        """
        pass

    def test_o_b_pv4_0_0_delete_account_cascade(self):
        """
        Test case for o_b_pv4_0_0_delete_account_cascade

        Delete Account Cascade
        """
        pass

    def test_o_b_pv4_0_0_delete_counterparty_for_any_account(self):
        """
        Test case for o_b_pv4_0_0_delete_counterparty_for_any_account

        Delete Counterparty for any account (Explicit)
        """
        pass

    def test_o_b_pv4_0_0_delete_explicit_counterparty(self):
        """
        Test case for o_b_pv4_0_0_delete_explicit_counterparty

        Delete Counterparty (Explicit)
        """
        pass

    def test_o_b_pv4_0_0_delete_tag_for_view_on_account(self):
        """
        Test case for o_b_pv4_0_0_delete_tag_for_view_on_account

        Delete a tag on account
        """
        pass

    def test_o_b_pv4_0_0_get_account_attribute_definition(self):
        """
        Test case for o_b_pv4_0_0_get_account_attribute_definition

        Get Account Attribute Definition
        """
        pass

    def test_o_b_pv4_0_0_get_account_by_account_routing(self):
        """
        Test case for o_b_pv4_0_0_get_account_by_account_routing

        Get Account by Account Routing
        """
        pass

    def test_o_b_pv4_0_0_get_accounts_by_account_routing_regex(self):
        """
        Test case for o_b_pv4_0_0_get_accounts_by_account_routing_regex

        Get Accounts by Account Routing Regex
        """
        pass

    def test_o_b_pv4_0_0_get_accounts_minimal_by_customer_id(self):
        """
        Test case for o_b_pv4_0_0_get_accounts_minimal_by_customer_id

        Get Accounts Minimal for a Customer
        """
        pass

    def test_o_b_pv4_0_0_get_bank_account_balances(self):
        """
        Test case for o_b_pv4_0_0_get_bank_account_balances

        Get Account Balances
        """
        pass

    def test_o_b_pv4_0_0_get_bank_accounts_balances(self):
        """
        Test case for o_b_pv4_0_0_get_bank_accounts_balances

        Get Accounts Balances
        """
        pass

    def test_o_b_pv4_0_0_get_core_account_by_id(self):
        """
        Test case for o_b_pv4_0_0_get_core_account_by_id

        Get Account by Id (Core)
        """
        pass

    def test_o_b_pv4_0_0_get_counterparties_for_any_account(self):
        """
        Test case for o_b_pv4_0_0_get_counterparties_for_any_account

        Get Counterparties for any account (Explicit)
        """
        pass

    def test_o_b_pv4_0_0_get_counterparty_by_id_for_any_account(self):
        """
        Test case for o_b_pv4_0_0_get_counterparty_by_id_for_any_account

        Get Counterparty by Id for any account (Explicit) 
        """
        pass

    def test_o_b_pv4_0_0_get_counterparty_by_name_for_any_account(self):
        """
        Test case for o_b_pv4_0_0_get_counterparty_by_name_for_any_account

        Get Counterparty by name for any account (Explicit) 
        """
        pass

    def test_o_b_pv4_0_0_get_explict_counterparties_for_account(self):
        """
        Test case for o_b_pv4_0_0_get_explict_counterparties_for_account

        Get Counterparties (Explicit)
        """
        pass

    def test_o_b_pv4_0_0_get_fast_firehose_accounts_at_one_bank(self):
        """
        Test case for o_b_pv4_0_0_get_fast_firehose_accounts_at_one_bank

        Get Fast Firehose Accounts at Bank
        """
        pass

    def test_o_b_pv4_0_0_get_firehose_accounts_at_one_bank(self):
        """
        Test case for o_b_pv4_0_0_get_firehose_accounts_at_one_bank

        Get Firehose Accounts at Bank
        """
        pass

    def test_o_b_pv4_0_0_get_private_account_by_id_full(self):
        """
        Test case for o_b_pv4_0_0_get_private_account_by_id_full

        Get Account by Id (Full)
        """
        pass

    def test_o_b_pv4_0_0_get_private_accounts_at_one_bank(self):
        """
        Test case for o_b_pv4_0_0_get_private_accounts_at_one_bank

        Get Accounts at Bank
        """
        pass

    def test_o_b_pv4_0_0_get_tags_for_view_on_account(self):
        """
        Test case for o_b_pv4_0_0_get_tags_for_view_on_account

        Get tags on account
        """
        pass

    def test_o_b_pv4_0_0_grant_user_access_to_view(self):
        """
        Test case for o_b_pv4_0_0_grant_user_access_to_view

        Grant User access to View
        """
        pass

    def test_o_b_pv4_0_0_iban_checker(self):
        """
        Test case for o_b_pv4_0_0_iban_checker

        Validate and check IBAN number
        """
        pass

    def test_o_b_pv4_0_0_revoke_grant_user_access_to_views(self):
        """
        Test case for o_b_pv4_0_0_revoke_grant_user_access_to_views

        Revoke/Grant User access to View
        """
        pass

    def test_o_b_pv4_0_0_revoke_user_access_to_view(self):
        """
        Test case for o_b_pv4_0_0_revoke_user_access_to_view

        Revoke User access to View
        """
        pass

    def test_o_b_pv4_0_0_update_account_label(self):
        """
        Test case for o_b_pv4_0_0_update_account_label

        Update Account Label
        """
        pass

    def test_o_b_pv5_0_0_create_account(self):
        """
        Test case for o_b_pv5_0_0_create_account

        Create Account
        """
        pass

    def test_o_b_pv5_0_0_create_customer_account_link(self):
        """
        Test case for o_b_pv5_0_0_create_customer_account_link

        Create Customer Account Link
        """
        pass

    def test_o_b_pv5_0_0_get_views_for_bank_account(self):
        """
        Test case for o_b_pv5_0_0_get_views_for_bank_account

        Get Views for Account
        """
        pass


if __name__ == '__main__':
    unittest.main()
