# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2022. Licensed under the AGPL and commercial licences.

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import os
import sys
import unittest

import obp_python
from obp_python.rest import ApiException
from obp_python.apis.counterparty_metadata_api import CounterpartyMetadataApi


class TestCounterpartyMetadataApi(unittest.TestCase):
    """ CounterpartyMetadataApi unit test stubs """

    def setUp(self):
        self.api = obp_python.apis.counterparty_metadata_api.CounterpartyMetadataApi()

    def tearDown(self):
        pass

    def test_o_b_pv1_2_1_add_counterparty_corporate_location(self):
        """
        Test case for o_b_pv1_2_1_add_counterparty_corporate_location

        Add Corporate Location to Counterparty
        """
        pass

    def test_o_b_pv1_2_1_add_counterparty_image_url(self):
        """
        Test case for o_b_pv1_2_1_add_counterparty_image_url

        Add image url to other bank account
        """
        pass

    def test_o_b_pv1_2_1_add_counterparty_more_info(self):
        """
        Test case for o_b_pv1_2_1_add_counterparty_more_info

        Add Counterparty More Info
        """
        pass

    def test_o_b_pv1_2_1_add_counterparty_open_corporates_url(self):
        """
        Test case for o_b_pv1_2_1_add_counterparty_open_corporates_url

        Add Open Corporates URL to Counterparty
        """
        pass

    def test_o_b_pv1_2_1_add_counterparty_physical_location(self):
        """
        Test case for o_b_pv1_2_1_add_counterparty_physical_location

        Add physical location to other bank account
        """
        pass

    def test_o_b_pv1_2_1_add_counterparty_public_alias(self):
        """
        Test case for o_b_pv1_2_1_add_counterparty_public_alias

        Add public alias to other bank account
        """
        pass

    def test_o_b_pv1_2_1_add_counterparty_url(self):
        """
        Test case for o_b_pv1_2_1_add_counterparty_url

        Add url to other bank account
        """
        pass

    def test_o_b_pv1_2_1_add_other_account_private_alias(self):
        """
        Test case for o_b_pv1_2_1_add_other_account_private_alias

        Create Other Account Private Alias
        """
        pass

    def test_o_b_pv1_2_1_delete_counterparty_corporate_location(self):
        """
        Test case for o_b_pv1_2_1_delete_counterparty_corporate_location

        Delete Counterparty Corporate Location
        """
        pass

    def test_o_b_pv1_2_1_delete_counterparty_image_url(self):
        """
        Test case for o_b_pv1_2_1_delete_counterparty_image_url

        Delete Counterparty Image URL
        """
        pass

    def test_o_b_pv1_2_1_delete_counterparty_more_info(self):
        """
        Test case for o_b_pv1_2_1_delete_counterparty_more_info

        Delete more info of other bank account
        """
        pass

    def test_o_b_pv1_2_1_delete_counterparty_open_corporates_url(self):
        """
        Test case for o_b_pv1_2_1_delete_counterparty_open_corporates_url

        Delete Counterparty Open Corporates URL
        """
        pass

    def test_o_b_pv1_2_1_delete_counterparty_physical_location(self):
        """
        Test case for o_b_pv1_2_1_delete_counterparty_physical_location

        Delete Counterparty Physical Location
        """
        pass

    def test_o_b_pv1_2_1_delete_counterparty_private_alias(self):
        """
        Test case for o_b_pv1_2_1_delete_counterparty_private_alias

        Delete Counterparty Private Alias
        """
        pass

    def test_o_b_pv1_2_1_delete_counterparty_public_alias(self):
        """
        Test case for o_b_pv1_2_1_delete_counterparty_public_alias

        Delete Counterparty Public Alias
        """
        pass

    def test_o_b_pv1_2_1_delete_counterparty_url(self):
        """
        Test case for o_b_pv1_2_1_delete_counterparty_url

        Delete url of other bank account
        """
        pass

    def test_o_b_pv1_2_1_get_counterparty_public_alias(self):
        """
        Test case for o_b_pv1_2_1_get_counterparty_public_alias

        Get public alias of other bank account
        """
        pass

    def test_o_b_pv1_2_1_get_other_account_metadata(self):
        """
        Test case for o_b_pv1_2_1_get_other_account_metadata

        Get Other Account Metadata
        """
        pass

    def test_o_b_pv1_2_1_get_other_account_private_alias(self):
        """
        Test case for o_b_pv1_2_1_get_other_account_private_alias

        Get Other Account Private Alias
        """
        pass

    def test_o_b_pv1_2_1_update_counterparty_corporate_location(self):
        """
        Test case for o_b_pv1_2_1_update_counterparty_corporate_location

        Update Counterparty Corporate Location
        """
        pass

    def test_o_b_pv1_2_1_update_counterparty_image_url(self):
        """
        Test case for o_b_pv1_2_1_update_counterparty_image_url

        Update Counterparty Image Url
        """
        pass

    def test_o_b_pv1_2_1_update_counterparty_more_info(self):
        """
        Test case for o_b_pv1_2_1_update_counterparty_more_info

        Update Counterparty More Info
        """
        pass

    def test_o_b_pv1_2_1_update_counterparty_open_corporates_url(self):
        """
        Test case for o_b_pv1_2_1_update_counterparty_open_corporates_url

        Update Open Corporates Url of Counterparty
        """
        pass

    def test_o_b_pv1_2_1_update_counterparty_physical_location(self):
        """
        Test case for o_b_pv1_2_1_update_counterparty_physical_location

        Update Counterparty Physical Location
        """
        pass

    def test_o_b_pv1_2_1_update_counterparty_private_alias(self):
        """
        Test case for o_b_pv1_2_1_update_counterparty_private_alias

        Update Counterparty Private Alias
        """
        pass

    def test_o_b_pv1_2_1_update_counterparty_public_alias(self):
        """
        Test case for o_b_pv1_2_1_update_counterparty_public_alias

        Update public alias of other bank account
        """
        pass

    def test_o_b_pv1_2_1_update_counterparty_url(self):
        """
        Test case for o_b_pv1_2_1_update_counterparty_url

        Update url of other bank account
        """
        pass

    def test_o_b_pv4_0_0_get_explict_counterparty_by_id(self):
        """
        Test case for o_b_pv4_0_0_get_explict_counterparty_by_id

        Get Counterparty by Id (Explicit)
        """
        pass


if __name__ == '__main__':
    unittest.main()
