# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2022. Licensed under the AGPL and commercial licences.

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import os
import sys
import unittest

import obp_python
from obp_python.rest import ApiException
from obp_python.apis.transaction_request_api import TransactionRequestApi


class TestTransactionRequestApi(unittest.TestCase):
    """ TransactionRequestApi unit test stubs """

    def setUp(self):
        self.api = obp_python.apis.transaction_request_api.TransactionRequestApi()

    def tearDown(self):
        pass

    def test_o_b_pv1_4_0_get_transaction_request_types(self):
        """
        Test case for o_b_pv1_4_0_get_transaction_request_types

        Get Transaction Request Types for Account
        """
        pass

    def test_o_b_pv2_1_0_create_transaction_request_sandbox_tan(self):
        """
        Test case for o_b_pv2_1_0_create_transaction_request_sandbox_tan

        Create Transaction Request (SANDBOX_TAN)
        """
        pass

    def test_o_b_pv2_1_0_get_transaction_request_types_supported_by_bank(self):
        """
        Test case for o_b_pv2_1_0_get_transaction_request_types_supported_by_bank

        Get Transaction Request Types at Bank
        """
        pass

    def test_o_b_pv3_1_0_get_transaction_requests(self):
        """
        Test case for o_b_pv3_1_0_get_transaction_requests

        Get Transaction Requests.
        """
        pass

    def test_o_b_pv3_1_0_save_historical_transaction(self):
        """
        Test case for o_b_pv3_1_0_save_historical_transaction

        Save Historical Transactions 
        """
        pass

    def test_o_b_pv4_0_0_answer_transaction_request_challenge(self):
        """
        Test case for o_b_pv4_0_0_answer_transaction_request_challenge

        Answer Transaction Request Challenge
        """
        pass

    def test_o_b_pv4_0_0_create_historical_transaction_at_bank(self):
        """
        Test case for o_b_pv4_0_0_create_historical_transaction_at_bank

        Create Historical Transactions 
        """
        pass

    def test_o_b_pv4_0_0_create_or_update_transaction_request_attribute_definition(self):
        """
        Test case for o_b_pv4_0_0_create_or_update_transaction_request_attribute_definition

        Create or Update Transaction Request Attribute Definition
        """
        pass

    def test_o_b_pv4_0_0_create_transaction_request_account(self):
        """
        Test case for o_b_pv4_0_0_create_transaction_request_account

        Create Transaction Request (ACCOUNT)
        """
        pass

    def test_o_b_pv4_0_0_create_transaction_request_account_otp(self):
        """
        Test case for o_b_pv4_0_0_create_transaction_request_account_otp

        Create Transaction Request (ACCOUNT_OTP)
        """
        pass

    def test_o_b_pv4_0_0_create_transaction_request_attribute(self):
        """
        Test case for o_b_pv4_0_0_create_transaction_request_attribute

        Create Transaction Request Attribute
        """
        pass

    def test_o_b_pv4_0_0_create_transaction_request_card(self):
        """
        Test case for o_b_pv4_0_0_create_transaction_request_card

        Create Transaction Request (CARD)
        """
        pass

    def test_o_b_pv4_0_0_create_transaction_request_counterparty(self):
        """
        Test case for o_b_pv4_0_0_create_transaction_request_counterparty

        Create Transaction Request (COUNTERPARTY)
        """
        pass

    def test_o_b_pv4_0_0_create_transaction_request_free_form(self):
        """
        Test case for o_b_pv4_0_0_create_transaction_request_free_form

        Create Transaction Request (FREE_FORM)
        """
        pass

    def test_o_b_pv4_0_0_create_transaction_request_refund(self):
        """
        Test case for o_b_pv4_0_0_create_transaction_request_refund

        Create Transaction Request (REFUND)
        """
        pass

    def test_o_b_pv4_0_0_create_transaction_request_sepa(self):
        """
        Test case for o_b_pv4_0_0_create_transaction_request_sepa

        Create Transaction Request (SEPA)
        """
        pass

    def test_o_b_pv4_0_0_create_transaction_request_simple(self):
        """
        Test case for o_b_pv4_0_0_create_transaction_request_simple

        Create Transaction Request (SIMPLE)
        """
        pass

    def test_o_b_pv4_0_0_delete_transaction_request_attribute_definition(self):
        """
        Test case for o_b_pv4_0_0_delete_transaction_request_attribute_definition

        Delete Transaction Request Attribute Definition
        """
        pass

    def test_o_b_pv4_0_0_get_transaction_request(self):
        """
        Test case for o_b_pv4_0_0_get_transaction_request

        Get Transaction Request.
        """
        pass

    def test_o_b_pv4_0_0_get_transaction_request_attribute_by_id(self):
        """
        Test case for o_b_pv4_0_0_get_transaction_request_attribute_by_id

        Get Transaction Request Attribute By Id
        """
        pass

    def test_o_b_pv4_0_0_get_transaction_request_attribute_definition(self):
        """
        Test case for o_b_pv4_0_0_get_transaction_request_attribute_definition

        Get Transaction Request Attribute Definition
        """
        pass

    def test_o_b_pv4_0_0_get_transaction_request_attributes(self):
        """
        Test case for o_b_pv4_0_0_get_transaction_request_attributes

        Get Transaction Request Attributes
        """
        pass

    def test_o_b_pv4_0_0_update_transaction_request_attribute(self):
        """
        Test case for o_b_pv4_0_0_update_transaction_request_attribute

        Update Transaction Request Attribute
        """
        pass


if __name__ == '__main__':
    unittest.main()
