# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2022. Licensed under the AGPL and commercial licences.

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import os
import sys
import unittest

import obp_python
from obp_python.rest import ApiException
from obp_python.apis.user_api import UserApi


class TestUserApi(unittest.TestCase):
    """ UserApi unit test stubs """

    def setUp(self):
        self.api = obp_python.apis.user_api.UserApi()

    def tearDown(self):
        pass

    def test_o_b_pv2_0_0_add_entitlement(self):
        """
        Test case for o_b_pv2_0_0_add_entitlement

        Add Entitlement for a User
        """
        pass

    def test_o_b_pv2_0_0_create_user(self):
        """
        Test case for o_b_pv2_0_0_create_user

        Create User
        """
        pass

    def test_o_b_pv2_0_0_delete_entitlement(self):
        """
        Test case for o_b_pv2_0_0_delete_entitlement

        Delete Entitlement
        """
        pass

    def test_o_b_pv2_0_0_get_permissions_for_bank_account(self):
        """
        Test case for o_b_pv2_0_0_get_permissions_for_bank_account

        Get access
        """
        pass

    def test_o_b_pv2_1_0_get_entitlements_by_bank_and_user(self):
        """
        Test case for o_b_pv2_1_0_get_entitlements_by_bank_and_user

        Get Entitlements for User at Bank
        """
        pass

    def test_o_b_pv3_0_0_add_entitlement_request(self):
        """
        Test case for o_b_pv3_0_0_add_entitlement_request

        Create Entitlement Request for current User
        """
        pass

    def test_o_b_pv3_0_0_delete_entitlement_request(self):
        """
        Test case for o_b_pv3_0_0_delete_entitlement_request

        Delete Entitlement Request
        """
        pass

    def test_o_b_pv3_0_0_get_all_entitlement_requests(self):
        """
        Test case for o_b_pv3_0_0_get_all_entitlement_requests

        Get all Entitlement Requests
        """
        pass

    def test_o_b_pv3_0_0_get_current_user(self):
        """
        Test case for o_b_pv3_0_0_get_current_user

        Get User (Current)
        """
        pass

    def test_o_b_pv3_0_0_get_customers_for_user(self):
        """
        Test case for o_b_pv3_0_0_get_customers_for_user

        Get Customers for Current User
        """
        pass

    def test_o_b_pv3_0_0_get_entitlement_requests(self):
        """
        Test case for o_b_pv3_0_0_get_entitlement_requests

        Get Entitlement Requests for a User
        """
        pass

    def test_o_b_pv3_0_0_get_entitlement_requests_for_current_user(self):
        """
        Test case for o_b_pv3_0_0_get_entitlement_requests_for_current_user

        Get Entitlement Requests for the current User
        """
        pass

    def test_o_b_pv3_0_0_get_entitlements_for_current_user(self):
        """
        Test case for o_b_pv3_0_0_get_entitlements_for_current_user

        Get Entitlements for the current User
        """
        pass

    def test_o_b_pv3_0_0_get_permission_for_user_for_bank_account(self):
        """
        Test case for o_b_pv3_0_0_get_permission_for_user_for_bank_account

        Get Account access for User
        """
        pass

    def test_o_b_pv3_1_0_delete_user_auth_context_by_id(self):
        """
        Test case for o_b_pv3_1_0_delete_user_auth_context_by_id

        Delete User Auth Context
        """
        pass

    def test_o_b_pv3_1_0_delete_user_auth_contexts(self):
        """
        Test case for o_b_pv3_1_0_delete_user_auth_contexts

        Delete User's Auth Contexts
        """
        pass

    def test_o_b_pv3_1_0_get_bad_login_status(self):
        """
        Test case for o_b_pv3_1_0_get_bad_login_status

        Get User Lock Status
        """
        pass

    def test_o_b_pv3_1_0_refresh_user(self):
        """
        Test case for o_b_pv3_1_0_refresh_user

        Refresh User
        """
        pass

    def test_o_b_pv3_1_0_unlock_user(self):
        """
        Test case for o_b_pv3_1_0_unlock_user

        Unlock the user
        """
        pass

    def test_o_b_pv4_0_0_create_current_user_attribute(self):
        """
        Test case for o_b_pv4_0_0_create_current_user_attribute

        Create User Attribute for current user
        """
        pass

    def test_o_b_pv4_0_0_create_user_customer_links(self):
        """
        Test case for o_b_pv4_0_0_create_user_customer_links

        Create User Customer Link
        """
        pass

    def test_o_b_pv4_0_0_create_user_with_account_access(self):
        """
        Test case for o_b_pv4_0_0_create_user_with_account_access

        Create (DAuth) User with Account Access
        """
        pass

    def test_o_b_pv4_0_0_create_user_with_roles(self):
        """
        Test case for o_b_pv4_0_0_create_user_with_roles

        Create (DAuth) User with Roles
        """
        pass

    def test_o_b_pv4_0_0_delete_user(self):
        """
        Test case for o_b_pv4_0_0_delete_user

        Delete a User
        """
        pass

    def test_o_b_pv4_0_0_get_current_user_attributes(self):
        """
        Test case for o_b_pv4_0_0_get_current_user_attributes

        Get User Attributes for current user
        """
        pass

    def test_o_b_pv4_0_0_get_current_user_id(self):
        """
        Test case for o_b_pv4_0_0_get_current_user_id

        Get User Id (Current)
        """
        pass

    def test_o_b_pv4_0_0_get_customers_at_any_bank(self):
        """
        Test case for o_b_pv4_0_0_get_customers_at_any_bank

        Get Customers at Any Bank
        """
        pass

    def test_o_b_pv4_0_0_get_customers_minimal_at_any_bank(self):
        """
        Test case for o_b_pv4_0_0_get_customers_minimal_at_any_bank

        Get Customers Minimal at Any Bank
        """
        pass

    def test_o_b_pv4_0_0_get_entitlements(self):
        """
        Test case for o_b_pv4_0_0_get_entitlements

        Get Entitlements for User
        """
        pass

    def test_o_b_pv4_0_0_get_entitlements_for_bank(self):
        """
        Test case for o_b_pv4_0_0_get_entitlements_for_bank

        Get Entitlements for One Bank
        """
        pass

    def test_o_b_pv4_0_0_get_logout_link(self):
        """
        Test case for o_b_pv4_0_0_get_logout_link

        Get Logout Link
        """
        pass

    def test_o_b_pv4_0_0_get_my_spaces(self):
        """
        Test case for o_b_pv4_0_0_get_my_spaces

        Get My Spaces
        """
        pass

    def test_o_b_pv4_0_0_get_user_by_user_id(self):
        """
        Test case for o_b_pv4_0_0_get_user_by_user_id

        Get User by USER_ID
        """
        pass

    def test_o_b_pv4_0_0_get_user_by_username(self):
        """
        Test case for o_b_pv4_0_0_get_user_by_username

        Get User by USERNAME
        """
        pass

    def test_o_b_pv4_0_0_get_user_with_attributes(self):
        """
        Test case for o_b_pv4_0_0_get_user_with_attributes

        Get User Attributes for the user
        """
        pass

    def test_o_b_pv4_0_0_get_users(self):
        """
        Test case for o_b_pv4_0_0_get_users

        Get all Users
        """
        pass

    def test_o_b_pv4_0_0_get_users_by_email(self):
        """
        Test case for o_b_pv4_0_0_get_users_by_email

        Get Users by Email Address
        """
        pass

    def test_o_b_pv4_0_0_grant_user_access_to_view(self):
        """
        Test case for o_b_pv4_0_0_grant_user_access_to_view

        Grant User access to View
        """
        pass

    def test_o_b_pv4_0_0_lock_user(self):
        """
        Test case for o_b_pv4_0_0_lock_user

        Lock the user
        """
        pass

    def test_o_b_pv4_0_0_reset_password_url(self):
        """
        Test case for o_b_pv4_0_0_reset_password_url

        Create password reset url
        """
        pass

    def test_o_b_pv4_0_0_revoke_grant_user_access_to_views(self):
        """
        Test case for o_b_pv4_0_0_revoke_grant_user_access_to_views

        Revoke/Grant User access to View
        """
        pass

    def test_o_b_pv4_0_0_revoke_user_access_to_view(self):
        """
        Test case for o_b_pv4_0_0_revoke_user_access_to_view

        Revoke User access to View
        """
        pass

    def test_o_b_pv4_0_0_update_current_user_attribute(self):
        """
        Test case for o_b_pv4_0_0_update_current_user_attribute

        Update User Attribute for current user
        """
        pass

    def test_o_b_pv5_0_0_answer_user_auth_context_update_challenge(self):
        """
        Test case for o_b_pv5_0_0_answer_user_auth_context_update_challenge

        Answer User Auth Context Update Challenge
        """
        pass

    def test_o_b_pv5_0_0_create_user_auth_context(self):
        """
        Test case for o_b_pv5_0_0_create_user_auth_context

        Create User Auth Context
        """
        pass

    def test_o_b_pv5_0_0_create_user_auth_context_update_request(self):
        """
        Test case for o_b_pv5_0_0_create_user_auth_context_update_request

        Create User Auth Context Update Request
        """
        pass

    def test_o_b_pv5_0_0_get_customers_at_one_bank(self):
        """
        Test case for o_b_pv5_0_0_get_customers_at_one_bank

        Get Customers at Bank
        """
        pass

    def test_o_b_pv5_0_0_get_customers_minimal_at_one_bank(self):
        """
        Test case for o_b_pv5_0_0_get_customers_minimal_at_one_bank

        Get Customers Minimal at Bank
        """
        pass

    def test_o_b_pv5_0_0_get_my_customers_at_any_bank(self):
        """
        Test case for o_b_pv5_0_0_get_my_customers_at_any_bank

        Get My Customers
        """
        pass

    def test_o_b_pv5_0_0_get_user_auth_contexts(self):
        """
        Test case for o_b_pv5_0_0_get_user_auth_contexts

        Get User Auth Contexts
        """
        pass


if __name__ == '__main__':
    unittest.main()
